<?php
if (!class_exists('UpiCRMPrivacy')) {
    class UpiCRMPrivacy {
        
        var $wpdb;
        public function __construct() {
            global $wpdb;
            $this->wpdb = &$wpdb;
        }
        
        function delete_files() {
            //delete all files that UPI created
            $dirPath = WP_CONTENT_DIR . "/uploads/upicrm";
            if ($handle = opendir($dirPath)) {
                while (false !== ($sub = readdir($handle))) {
                    if ($sub != "." && $sub != ".." ) {
                        $file = $dirPath .'/'.$sub;
                        @unlink($file);
                    }
                }

                closedir($handle);
            }
        }
        
        function is_files_exist() {
            //check if files existing in the server, return true/false
            $dirPath = WP_CONTENT_DIR . "/uploads/upicrm";
            
            if (file_exists($dirPath)) {
                if ($handle = opendir($dirPath)) {
                    while (false !== ($sub = readdir($handle))) {
                        if ($sub != "." && $sub != ".." ) {
                            if (isset($sub)) {
                                return true;
                            }
                        }
                    }
                    return false;
                }
            }
            
            return false;
        }
        
        
        function delete_files_note() {
            //show note in admin
            ?>
            <div class="notice notice-warning is-dismissible upicrm_notice">
                <p><?php _e('<strong>UpiCRM - Important Notice:</strong> every time you export leads from UPICRM to excel or csv – a temporary file with all the leads information is generated and stored on the server. UpiCRM will delete this file upon every upgrade to a newer version of UPICRM, and the file name also have a random hash characters – in order to prevent malicious download of the stored private information.<br />
Please make sure you manually delete this file  after you have downloaded it, in order to protect sensitive and private information.<br />
 <a href="admin.php?page=upicrm_privacy&action=delete_files">Delete previously exported files</a>', 'upicrm'); ?></p>
            </div>
            <?php
        }
    }
}