<?php

if (!class_exists('UpiCRMFields')) {

    class UpiCRMFields extends WP_Widget {

        var $wpdb;

        public function __construct() {
            global $wpdb;
            $this->wpdb = &$wpdb;
        }

        function get($order=1) {
            //get all fields
            if ($order == 1) {
                $field_order = 'field_order';
            } else {
                $field_order = 'field_order2';
            }
            $rows = $this->wpdb->get_results("SELECT * FROM " . upicrm_db() . "fields ORDER BY `$field_order` ASC");
            return $rows;
        }

        function get_name_by_id($field_id) {
            //get all fields
            $rows = $this->wpdb->get_results("SELECT `field_name` FROM " . upicrm_db() . "fields WHERE `field_id`={$field_id}");
            return $rows[0]->field_name;
        }

        function get_id_by_name($field_name) {
            //get all fields
            $rows = $this->wpdb->get_results("SELECT `field_id` FROM " . upicrm_db() . "fields WHERE `field_name`='{$field_name}' ORDER BY `field_order` ASC");

            if (!empty($rows)) {
                return $rows[0]->field_id;
            } else
                return;
        }

        function get_as_array($order=1) {
            //get all fields as array (array[id] => name)
            if ($order == 1) {
                $field_order = 'field_order';
            } else {
                $field_order = 'field_order2';
            }
            $rows = $this->wpdb->get_results("SELECT * FROM " . upicrm_db() . "fields ORDER BY `$field_order` ASC");

            foreach ($rows as $row)
                $arr[$row->field_id] = $row->field_name;

            return $arr;
        }

        function add($field_name) {
            //add field
            $row = $this->wpdb->get_results("SELECT `field_order` FROM " . upicrm_db() . "fields ORDER BY `field_order` DESC LIMIT 1");
            $field_order = $row[0]->field_order+1;
            $this->wpdb->insert(upicrm_db() . "fields", array("field_name" => $field_name, "field_order" => $field_order));
        }

        function is_exists($field_name) {
            //checks if the field is already existing 
            $rows = $this->wpdb->get_results("SELECT `field_id` FROM " . upicrm_db() . "fields WHERE `field_name` = '{$field_name}'");
            return count($rows) > 0 ? true : false;
        }

        /**
         * @param $field_name
         */
        function add_unique($field_name) {
            //add unique field name, if name is already exist then add to name 1,2,3 etc

            if (!$this->is_exists($field_name)) {
                $this->add($field_name);
            } else {
                $i = 1;
                do {
                    $i++;
                    $field_name_new = $field_name . $i;
                } while ($this->is_exists($field_name_new));
                $this->add($field_name_new);
            }

            //$this->add($field_name);
        }
        
        function update($updateArr, $field_id) {
            //update lead route
            $this->wpdb->update(upicrm_db() . "fields", $updateArr, array("field_id" => $field_id));
        }

    }

}